"use strict";

var run = require("./run_scripts_sync").run;
const fs = require("fs");
var gen_random_content = require("../unit_tests/random_gen").gen_random_content;
var args = JSON.parse(process.argv[2]);

var stream = fs.createWriteStream(args.result_file, {flags: "w+"});
stream.write(args.titles + "\n");

var to_run = [];

if (args.files_dir) {
    fs.readdir(args.files_dir, function (err, items) {
        if (err) {
            return console.log("Unable to scan directory: " + err);
        }
        items.forEach(function (file) {
            if (args.file === undefined || file.includes(args.file)) {
                var to_pass = [...args.to_pass];
                to_pass.push("-f");
                to_pass.push(args.files_dir + file);
                to_run.push({scriptPath: "./unit_tests/" + args.script,
                    args: to_pass});
            }
        });
        console.log("Starting " + args.script);
        run(to_run, args.result_file, function (err) {
            if (err) {
                throw err;
            }
        });
    });
} else {
    var random_file = gen_random_content(args.paragraphs);
    var to_pass = [...args.to_pass];
    to_pass.push("-f");
    to_pass.push(random_file);
    to_run.push({scriptPath: "./unit_tests/" + args.script,
        args: to_pass});
    run(to_run, args.result_file, function (err) {
        if (err) {
            throw err;
        }
    });
}