"use strict";

module.exports = {
    run: function (args, filepath, callback) {
        var ipc = require("node-ipc");
        ipc.config.silent = true;
        ipc.connectTo("main");

        var childProcess = require("child_process");
        const fs = require("fs");
        var stream = fs.createWriteStream(filepath, {flags: "a"});

        function write(message) {
            if (filepath === "") {
                return;
            }
            stream.write(message + "\n");
        }

        if (args.length === 0) {
            ipc.of.main.emit("message", "DONE");
            return;
        }

        var invoked = false;
        var to_run = args.shift();
        console.log(to_run.args);
        var process = childProcess.fork(to_run.scriptPath, to_run.args);

        process.on("message", function (mes) {
            mes = mes.toString();
            if (mes.includes("DONE")) {
                module.exports.run(args, filepath, callback);
            } else {
                ipc.of.main.emit("message", mes);
                write(mes);
                if (mes.includes("ERROR")) {
                    module.exports.run(args, filepath, callback);
                }
            }
        });

        process.on("error", function (err) {
            if (invoked) {
                return;
            }
            invoked = true;
            callback(err);
        });

        process.on("exit", function (code) {
            if (invoked) {
                return;
            }
            invoked = true;
            var err = code === 0
                ? null
                : new Error("exit code " + code);
            callback(err);
        });
    }
};
